Index: clientloop.c
===================================================================
RCS file: /usr/local/src/security/openssh/cvs/openssh_cvs/clientloop.c,v
retrieving revision 1.114
diff -u -p -r1.114 clientloop.c
--- clientloop.c	13 Aug 2004 11:18:01 -0000	1.114
+++ clientloop.c	18 Oct 2004 09:26:08 -0000
@@ -1685,12 +1685,13 @@ client_session2_setup(int id, int want_t
 	if (want_tty) {
 		struct winsize ws;
 		struct termios tio;
+		u_int rid, type;
 
 		/* Store window size in the packet. */
 		if (ioctl(in_fd, TIOCGWINSZ, &ws) < 0)
 			memset(&ws, 0, sizeof(ws));
 
-		channel_request_start(id, "pty-req", 0);
+		channel_request_start(id, "pty-req", 1);
 		packet_put_cstring(term != NULL ? term : "");
 		packet_put_int(ws.ws_col);
 		packet_put_int(ws.ws_row);
@@ -1699,7 +1700,28 @@ client_session2_setup(int id, int want_t
 		tio = get_saved_tio();
 		tty_make_modes(-1, tiop != NULL ? tiop : &tio);
 		packet_send();
-		/* XXX wait for reply */
+		packet_write_wait();
+
+		/* Read response from the server. */
+		type = packet_read();
+		if (type == SSH2_MSG_CHANNEL_SUCCESS ||
+		    type == SSH2_MSG_CHANNEL_FAILURE)
+			rid = packet_get_int();
+		packet_check_eom();
+		if (id != rid)
+			packet_disconnect("Channel response != request");
+
+		switch(type) {
+		case SSH2_MSG_CHANNEL_SUCCESS:
+			break;
+		case SSH2_MSG_CHANNEL_FAILURE:
+			logit("Warning: Remote host failed or refused to "
+			    "allocate a pseudo tty.");
+			break;
+		default:
+			packet_disconnect("Protocol error waiting for pty "
+			    " request response.");
+		}
 	}
 
 	/* Transfer any environment variables from client to server */
